
import axios from 'axios'
import TokenModule from './_tableHandle'
class InterceptorsAxiosToken {
    constructor() {
        this.moduleName = 'InterceptorsTokenAxiosModule'
    }
    initInterceptors () {
        // 增加一个response拦截器
        axios.interceptors.response.use(
            function (response) {
                return response
            },
            async function (error) {
                // 如果返回的code中token 过期了则刷新token
                const code = error.response && error.response.status
                const resData = (error.response && error.response.data) || {}
                if (code === 401 && resData.error_type === 'expired' && self !== top) { // 401时过期了把请求缓存起来,等待webframe刷新token后再统一请求!
                    return TokenModule.hand401Meaage(error.response.config)// 这是一个promise
                } else {
                    return error
                }
            }
        )
        axios.interceptors.request.use(
            async config => {
                config.headers['Authorization'] = sessionStorage['token']
                return config
            },
            err => {
                return err
            }
        )
    }
}
export default new InterceptorsAxiosToken()
